freeslot(
    "SPR_HART",
	"SPR_CHRT",
	"MT_CAPEHAMMER",
	"MT_HEART",
	"MT_HEARTATTACK",
	"MT_BLINKHEART",
	"MT_ORBITHEART",
	"S_CAPEHAMMER",
	"S_HAMMERCHASE1",
	"S_HAMMERCHASE2",
	"S_PLAY_CYCLONE",
	"S_PLAY_TWIRL1",
	"S_PLAY_TWIRL2",
	"S_PLAY_TWIRL3",
	"S_PLAY_TWIRL4",
	"S_PLAY_TWIRL5",
	"S_PLAY_TWIRL6",
	"S_PLAY_TWIRL7",
	"S_PLAY_TWIRL8",
	"S_PLAY_TWIRL9",
	"S_PLAY_TWIRL10",
	"S_PLAY_TWIRL11",
	"S_PLAY_TWIRL12",
	"S_PLAY_HAMMER1",
	"S_PLAY_HAMMER2",
	"S_PLAY_HAMMER3",
	"S_PLAY_HAMMER4",
	"S_PLAY_HAMMER5",
	"S_PLAY_HAMMER6",
	"S_PLAY_HAMMERDOWN1",
	"S_PLAY_HAMMERDOWN2",
	"S_PLAY_HAMMERDOWN3",
	"S_PLAY_HAMMERDOWN4",
	"S_PLAY_HAMMERDOWN5",
	"S_PLAY_HAMMERDOWN6",
	"S_PLAY_LAUNCH",
	"S_PLAY_ROSYCHARGE",
	"S_PLAY_ROSYDASH",
	"S_PLAY_ROSYSLIDE",
	"S_HEART",
	"S_HEARTATTACK",
	"S_BLINKHEART",
	"S_ORBITHEART1",
	"S_ORBITHEART2"
)

mobjinfo[MT_CAPEHAMMER] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_CAPEHAMMER,
	seestate = S_HAMMERCHASE1,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOBLOCKMAP
}

mobjinfo[MT_HEART] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_HEART,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_HEARTATTACK] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_HEARTATTACK,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_SCENERY
}

mobjinfo[MT_BLINKHEART] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_BLINKHEART,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_ORBITHEART] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_ORBITHEART1,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}

states[S_CAPEHAMMER] = {SPR_NULL, 0, 1, nil, 0, 0, S_HAMMERCHASE1}
states[S_HAMMERCHASE1] = {SPR_NULL, 0, 1, A_CapeChase, 0, 50<<16, S_HAMMERCHASE2}
states[S_HAMMERCHASE2] = {SPR_NULL, 0, 1, A_CapeChase, 0, 50<<16, S_HAMMERCHASE1}

states[S_PLAY_CYCLONE] = {SPR_PLAY, SPR2_FLY_, 1, nil, 0, 0, S_PLAY_CYCLONE}

states[S_PLAY_TWIRL1] = {SPR_PLAY, SPR2_TWIN, 1, A_PlaySound, sfx_mswing, 1, S_PLAY_TWIRL2}
states[S_PLAY_TWIRL2] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL3}
states[S_PLAY_TWIRL3] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL4}
states[S_PLAY_TWIRL4] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL5}
states[S_PLAY_TWIRL5] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL6}
states[S_PLAY_TWIRL6] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL7}
states[S_PLAY_TWIRL7] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL8}
states[S_PLAY_TWIRL8] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL9}
states[S_PLAY_TWIRL9] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL10}
states[S_PLAY_TWIRL10] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL11}
states[S_PLAY_TWIRL11] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_TWIRL12}
states[S_PLAY_TWIRL12] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_FALL}

states[S_PLAY_HAMMER1] = {SPR_PLAY, SPR2_TWIN, 2, nil, 0, 0, S_PLAY_HAMMER2}
states[S_PLAY_HAMMER2] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMER3}
states[S_PLAY_HAMMER3] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMER4}
states[S_PLAY_HAMMER4] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMER5}
states[S_PLAY_HAMMER5] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMER6}
states[S_PLAY_HAMMER6] = {SPR_PLAY, SPR2_MLEL, 2, A_PlaySound, sfx_s3k8b, 1, S_PLAY_FALL}

states[S_PLAY_HAMMERDOWN1] = {SPR_PLAY, SPR2_TWIN, 2, A_ZThrust, 10, 0, S_PLAY_HAMMERDOWN2}
states[S_PLAY_HAMMERDOWN2] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMERDOWN3}
states[S_PLAY_HAMMERDOWN3] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMERDOWN4}
states[S_PLAY_HAMMERDOWN4] = {SPR_PLAY, SPR2_MLEE, 2, A_ZThrust, -30, 1, S_PLAY_HAMMERDOWN5}
states[S_PLAY_HAMMERDOWN5] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HAMMERDOWN6}
states[S_PLAY_HAMMERDOWN6] = {SPR_PLAY, SPR2_MLEL, -1, nil, 0, 0, S_PLAY_FALL}

states[S_PLAY_LAUNCH] = {SPR_PLAY, SPR2_MLEL, 20, nil, 0, 0, S_PLAY_FALL}

states[S_PLAY_ROSYCHARGE] = {SPR_PLAY, SPR2_RUN_, 1, nil, 0, 0, S_PLAY_ROSYCHARGE}

states[S_PLAY_ROSYDASH] = {SPR_PLAY, SPR2_RUN_, 1, nil, 0, 0, S_PLAY_ROSYDASH}

states[S_PLAY_ROSYSLIDE] = {SPR_PLAY, SPR2_PAIN, 1, nil, 0, 0, S_PLAY_ROSYSLIDE}

states[S_HEART] = {SPR_HART, TR_TRANS20|FF_FULLBRIGHT, -1, nil, 0, 0, S_NULL}

states[S_HEARTATTACK] = {SPR_NULL, 0, -1, nil, 0, 0, S_NULL}

states[S_BLINKHEART] = {SPR_HART, TR_TRANS20|FF_FULLBRIGHT, 5, nil, 0, 0, S_NULL}

states[S_ORBITHEART1] = {SPR_HART, TR_TRANS20|FF_FULLBRIGHT, 1, A_Custom3DRotate, 50+10<<16, 100<<16, S_ORBITHEART2}
states[S_ORBITHEART2] = {SPR_HART, TR_TRANS20|FF_FULLBRIGHT, 1, A_Custom3DRotate, 50+10<<16, 100<<16, S_ORBITHEART1}

addHook("AbilitySpecial", function(player) //Hammer Twirl
    if player.mo and player.mo.skin == "rosy"
	and player.pflags & PF_JUMPED
	and not player.weapondelay
	and not (player.mo.cyclone == 1)
	and not (player.mo.leap == 1)
	and not (player.pflags & PF_SHIELDABILITY)
		player.mo.state = S_PLAY_TWIRL1
		player.weapondelay = TICRATE-10
		player.twirl = 1
		player.pflags = $1|PF_THOKKED
		return true
    end 
    if (player.mo.cyclone == 1)
	    player.pflags = $1 & ~PF_THOKKED
		player.mo.cyclone = 0
		player.mo.state = S_PLAY_FALL
	end
end)

addHook("MobjSpawn", function(mo) mo.cape = nil end, MT_PLAYER)

local function RosyHammer(rosy)
local player = rosy.player
if (player and rosy.skin == "rosy")
	if (player.mo.cape == nil)
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		local hammer = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height, MT_CAPEHAMMER)
		hammer.target = rosy
		player.mo.cape = 1
		end
		
		if not (player.mo.falltimer)
			player.mo.falltimer = 0
		end
		
		if (player.mo.falltimer > 0)
			player.mo.falltimer = $ - 1
		end
		
		//Weak Hammer Jump
		 if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_CUSTOM1)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not player.weapondelay
			and (player.playerstate == PST_LIVE)
			and not (player.panim == PA_RUN or player.mo.state == S_PLAY_ROSYDASH)
			//and not P_IsObjectOnGround(player.mo)
				if not (player.pflags & PF_SHIELDABILITY)
					player.mo.state = S_PLAY_LAUNCH
		            player.pflags = $1|PF_THOKKED     
					player.mo.hammerjump = 1
					S_StartSound(player.mo, sfx_s3k8b)
					if (player.powers[pw_super])
			            A_ZThrust(player.mo, 30, 0)
						S_StartSound(player.mo, sfx_zoom)
						P_NukeEnemies(player.mo, player.mo, 500*FRACUNIT)
                        P_StartQuake(15*FRACUNIT, 5)
					else
					    A_ZThrust(player.mo, 15, 0)
					end
					player.weapondelay = TICRATE-30
				end
			end
		end
		
	//Strong Hammer Jump
		 if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_CUSTOM1)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not player.weapondelay
			and (player.playerstate == PST_LIVE)
			and (player.panim == PA_RUN or player.mo.state == S_PLAY_ROSYDASH and player.weapondelay)
			//and not P_IsObjectOnGround(player.mo)
				if not (player.pflags & PF_SHIELDABILITY)
					player.mo.state = S_PLAY_LAUNCH
		            player.pflags = $1|PF_THOKKED
					player.mo.hammerjump = 1
					S_StartSound(player.mo, sfx_s3k8b)
			        if (player.powers[pw_super])
			            A_ZThrust(player.mo, 40, 0)
						S_StartSound(player.mo, sfx_zoom)
						P_NukeEnemies(player.mo, player.mo, 500*FRACUNIT)
                        P_StartQuake(15*FRACUNIT, 5)
					else
					    A_ZThrust(player.mo, 20, 0)
					end
					player.weapondelay = TICRATE-30
				end
			end
		end
	
    //Ground Hammer
	    if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_SPIN)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not player.weapondelay
			and (player.playerstate == PST_LIVE)
			and not (player.panim == PA_RUN or player.mo.state == S_PLAY_ROSYDASH and player.weapondelay)
			//and not P_IsObjectOnGround(player.mo)
				if not (player.pflags & PF_SHIELDABILITY)
				    if (player.powers[pw_super])
					    P_Thrust(player.mo, player.drawangle, 6*FRACUNIT)
					else
					    player.weapondelay = TICRATE-10
						P_InstaThrust(player.mo, player.drawangle, 1*FRACUNIT)
						if CBW_Battle
						    player.weapondelay = TICRATE-2
							end
					    end  
		            player.pflags = $1|PF_THOKKED
	                if (player.mo.eflags & MFE_UNDERWATER)
			            A_ZThrust(player.mo, 2, 0)
		            else
			            A_ZThrust(player.mo, 5, 0)
			            end
					player.mo.state = S_PLAY_HAMMER1
				end
			end
		end
		
	//Hammer Leap
	    if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_SPIN)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not player.weapondelay
			and (player.playerstate == PST_LIVE)
			and (player.panim == PA_RUN or player.mo.state == S_PLAY_ROSYDASH)
				if not (player.pflags & PF_SHIELDABILITY)
					player.mo.state = S_PLAY_CYCLONE
		            player.pflags = $1|PF_JUMPED|PF_THOKKED
					player.mo.leap = 1
			        A_ZThrust(player.mo, 5, 0)
					player.weapondelay = TICRATE
					S_StartSound(player.mo, sfx_mswing)
				    for i = 0, 8, 1 do
					    local orbit = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height, MT_ORBITHEART)
					    orbit.target = player.mo
					    orbit.scale = orbit.target.scale
					    orbit.angle = i*ANGLE_45
					end
				end
			end
		end
		
	//Peelout
		 if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_CUSTOM2)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not (player.mo.rosycharge == 1)
			and not (player.mo.rosydash == 1)
			and (player.playerstate == PST_LIVE)
			and (player.speed < 4*FRACUNIT)
				if not (player.pflags & PF_SHIELDABILITY)
					player.mo.state = S_PLAY_ROSYCHARGE
					player.pflags = $1|PF_STARTDASH|PF_SPINNING
					player.mo.rosycharge = 1
					S_StartSound(player.mo, sfx_cdfm11)
				end
			end
		end
		
		 if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if not (player.cmd.buttons & BT_CUSTOM2)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and (player.mo.rosycharge == 1)
			and not (player.mo.rosydash == 1)
			and (player.playerstate == PST_LIVE)
			//and not P_IsObjectOnGround(player.mo)
				if not (player.pflags & PF_SHIELDABILITY)
					player.mo.state = S_PLAY_ROSYDASH
					player.weapondelay = 1*TICRATE
					player.pflags = $1 & ~PF_SPINNING
					if (player.powers[pw_super])
					    P_InstaThrust(player.mo, player.drawangle, 90*FRACUNIT)
					else
					    P_InstaThrust(player.mo, player.drawangle, 45*FRACUNIT)
						end
					player.mo.rosycharge = 0
					player.mo.rosydash = 1
					S_StartSound(player.mo, sfx_cdfm01)
				end
			end
		end
		
	//Slide
		if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_CUSTOM2)
			and P_IsObjectOnGround(player.mo)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.cyclone == 1)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not (player.mo.rosycharge == 1)
			and not (player.mo.rosydash == 1)
			and not (player.mo.slide == 1)
			and (player.playerstate == PST_LIVE)
			and (player.speed > 4*FRACUNIT)
			//and not P_IsObjectOnGround(player.mo)
				if not (player.pflags & PF_SHIELDABILITY)
					player.mo.slidestate = 1
					player.pflags = $1|PF_SLIDING
					P_InstaThrust(player.mo, player.drawangle, 50*FRACUNIT)
					P_SpawnSpinMobj(player, MT_THOK)
					player.powers[pw_nocontrol] = 32767
					player.mo.slide = 1
				end
			end
		end
		
	//Cyclone Drill
		if (player and player.mo and player.mo.valid and player.mo.skin == "rosy")
			if (player.cmd.buttons & BT_SPIN)
			and not (player.mo.cyclone == 1)
			and not (player.mo.hammerjump == 1)
			and not (player.mo.falltimer > 0)
			and not (player.panim == PA_ABILITY2)
			and not P_IsObjectOnGround(player.mo)
			and not P_InQuicksand(player.mo)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			and not (player.powers[pw_carry] == CR_NIGHTSFALL)
			and not (player.powers[pw_carry] == CR_ROPEHANG)
			and not (player.powers[pw_carry] == CR_MACESPIN)
			and not (player.powers[pw_carry] == CR_ZOOMTUBE)
			and not (player.powers[pw_carry] == CR_MINECART)
			and not (player.powers[pw_carry] == CR_ROLLOUT)
			and not (player.powers[pw_carry] == CR_GENERIC)
			and not (player.powers[pw_carry] == CR_PLAYER)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not P_PlayerInPain(player)
			and not P_CheckDeathPitCollide(player.mo)
			and not (player.skidtime > 0)
			and not (player.exiting)
			and not (player.gotflag)
			and not player.weapondelay
			and (player.playerstate == PST_LIVE)
			and (player.pflags & PF_JUMPED)
			//and not P_IsObjectOnGround(player.mo)
				if not (player.pflags & PF_SHIELDABILITY)
					player.pflags = $1|PF_THOKKED
					player.mo.cyclone = 1
					A_ZThrust(player.mo, -20, 0)
					player.mo.state = S_PLAY_CYCLONE
					S_StartSound(player.mo, sfx_mswing)
					player.mo.falltimer = TICRATE
				end
			end
		end

		if (player.mo.hammerjump == 1)
		and P_IsObjectOnGround(player.mo)
		    player.mo.hammerjump = 0
		end
		
		if (player.mo.state == S_PLAY_HAMMER5) or (player.mo.state == S_PLAY_HAMMER6) or (player.mo.state == S_PLAY_CYCLONE) or (player.mo.state >= S_PLAY_TWIRL1) and (player.mo.state <= S_PLAY_TWIRL12) or (player.mo.state == S_PLAY_HAMMERDOWN5) or (player.mo.state == S_PLAY_HAMMERDOWN6)
		    player.hammer = 1
		else
		    player.hammer = 0
		end
		
		if player.twirl == 1 or player.mo.cyclone == 1 or player.mo.leap == 1 or player.hammer == 1
			local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
			if sectorthing.valid then
				for fof in sectorthing.ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and not (tracer and tracer.type == MT_TUBEWAYPOINT)
					and not player.powers[pw_carry]
					and (abs(fof.topheight - player.mo.z) <= 30*player.mo.scale) then
						EV_CrumbleChain(player.sectorthing, fof)
					end
				end
			end
		end
		
		if (player.mo.rosydash == 1)
		and (player.powers[pw_super])
		    player.powers[pw_nocontrol] = 65534
		    P_SpawnGhostMobj(player.mo)
			P_InstaThrust(player.mo, player.mo.angle, 90*FRACUNIT)
		elseif (player.mo.rosydash == 1)
		and not (player.powers[pw_super])
		    player.powers[pw_nocontrol] = 65534
		    P_SpawnGhostMobj(player.mo)
		    P_InstaThrust(player.mo, player.mo.angle, 45*FRACUNIT)
		end
		
		if not (player.mo.state == S_PLAY_ROSYDASH or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_LAUNCH or player.mo.state == S_PLAY_CYCLONE)
		and (player.mo.rosydash == 1)
		and not P_IsObjectOnGround(player.mo)
		    player.mo.rosydash = 0
			player.mo.state = S_PLAY_SPRING
			player.powers[pw_nocontrol] = 0
		end
		
		if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
	    and (player.mo.rosydash == 1)
		    player.mo.state = S_PLAY_ROSYDASH
		end
		
		if not (player.mo.state == S_PLAY_ROSYCHARGE)
		and (player.mo.rosycharge == 1)
		    player.mo.rosycharge = 0
		end
		
		if (player.mo.rosydash == 1)
		    player.drawangle = player.mo.angle
		end

		if (player.weapondelay == 0)
		and (player.mo.rosydash == 1)
			if not (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_CYCLONE or player.mo.state == S_PLAY_LAUNCH)
                player.mo.state = S_PLAY_RUN
				player.mo.rosydash = 0
				player.powers[pw_nocontrol] = 0
			else
			    player.mo.rosydash = 0
				player.powers[pw_nocontrol] = 0
			end
			return nil
		end
		
		if (player.mo.state == S_PLAY_ROSYDASH)
		and (player.mo.rosydash == 0)
		    player.mo.state = S_PLAY_RUN
		end
		
		if (player.mo.rosydash == 1)
		and P_PlayerInPain(player)
		and (player.powers[pw_nocontrol])
		    player.powers[pw_nocontrol] = 0
		end
		
		if (player.mo.rosydash == 1)
		and (player.mo.state == S_PLAY_WALK)
		and (player.powers[pw_nocontrol])
		    player.powers[pw_nocontrol] = 0
		end
		
		if (player.mo.rosydash == 1)
		and (player.mo.state == S_PLAY_RUN)
		and (player.powers[pw_nocontrol])
		    player.powers[pw_nocontrol] = 0
		end
		
		if (player.mo.rosydash == 1)
		and (player.mo.state == S_PLAY_SPRING)
		and (player.powers[pw_nocontrol])
		    player.powers[pw_nocontrol] = 0
		end
		
		if ((player.mo.ceilingz - player.mo.floorz) < skins[player.mo.skin].height + FRACUNIT)		
			player.pflags = $1|MF_SLIDEME
			P_InstaThrust(player.mo, player.mo.angle, FixedMul(50*FRACUNIT, player.mo.scale))
			player.mo.state = S_PLAY_ROSYSLIDE
			player.mo.slide = 1
			player.mo.slidestate = 1
		    player.height = P_GetPlayerSpinHeight(player)
		end
		
		if (player.mo.state == S_PLAY_HAMMER6)
	    and (player.powers[pw_super])
	        P_NukeEnemies(player.mo, player.mo, 500*FRACUNIT)
            P_StartQuake(15*FRACUNIT, 5)
		end
		
		if (player.mo.state == S_PLAY_FALL)
		and (player.twirl == 1)
		    player.twirl = 0
		end
		
		if P_IsObjectOnGround(player.mo)
		and (player.twirl == 1) 
		    player.twirl = 0
		end
		
		if P_IsObjectOnGround(player.mo)
		and (player.mo.rosydash == 1)
		and (player.weapondelay)
		and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_SPRING)
		    player.mo.rosydash = 1
			player.powers[pw_nocontrol] = 65534
		    P_SpawnGhostMobj(player.mo)
			P_InstaThrust(player.mo, player.mo.angle, 90*FRACUNIT)
		end
		
		if (player.mo.state == S_PLAY_HAMMER6)
		and CBW_Battle
		    local fa
	        local ns
		    local x
		    local y
		    local fake
		    local heart
			local position
				    for i = 0, 16, 1 do
					    fa = i*ANGLE_22h
					    ns = 20*FRACUNIT
						position = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height, MT_CAPEHAMMER)
						position.target = player.mo
						A_CapeChase(position, 0, 50<<16)
					    x = position.x + FixedMul(FixedMul(sin(fa),ns), player.mo.scale)
					    y = position.y + FixedMul(FixedMul(cos(fa),ns), player.mo.scale)
					    fake = P_SpawnMobj(x, y, position.z, MT_HEARTATTACK)
					    fake.target = player.mo
					    fake.fuse = TICRATE/10
					    fake.scale = player.mo.scale
					    fake.flags2 = $1|MF2_DEBRIS
					    fake.momx = FixedMul(FixedMul(sin(fa),ns), fake.scale)
					    fake.momy = FixedMul(FixedMul(cos(fa),ns), fake.scale)
					    heart = P_SpawnMobj(x, y, position.z, MT_HEART)
					    heart.target = player.mo
					    heart.fuse = TICRATE/10
					    heart.scale = player.mo.scale
					    heart.flags2 = $1|MF2_DEBRIS
					    heart.momx = FixedMul(FixedMul(sin(fa),ns), heart.scale)
					    heart.momy = FixedMul(FixedMul(cos(fa),ns), heart.scale)
					end
				end
		
		if (player.mo.state == S_PLAY_ROLL)
		    player.rolling = 1
		else
		    player.rolling = 0
		end
		
		if (player.mo.rosycharge == 1)
		    A_BossScream(player.mo, 0, MT_BLINKHEART)
		end
			
		if (player.pflags & PF_JUMPED)
		and (player.mo.rosycharge == 1)
		    player.mo.rosycharge = 0
		end
		
		if (player.mo.slide == 1)
		    P_Telekinesis(player, 80*FRACUNIT, 48*FRACUNIT)
		end
			
		if (player.powers[pw_justsprung])
		and (player.mo.slide == 1)
		    player.powers[pw_nocontrol] = 0
			player.mo.slide = 0
			player.mo.slidestate = 0
		end
		
		if (player.mo.slidestate == 1)
		    player.mo.state = S_PLAY_ROSYSLIDE
		    player.height = P_GetPlayerSpinHeight(player)
		else
		    player.height = 48*FRACUNIT
		end
		
		if (player.mo.slidestate == 1)
		and (player.powers[pw_shield] == SH_ELEMENTAL)
		    P_ElementalFire(player)
		end
		
		if (player.speed < 5)
        and (player.mo.slide == 1)
			player.mo.slide = 0
			player.mo.state = S_PLAY_STND
			player.mo.slidestate = 0
			player.pflags = $1 & ~PF_SLIDING
			player.powers[pw_nocontrol] = 0
		end
		
		if (player.mo.slidestate == 1)
		    player.mo.flags = $1|MF_SLIDEME
		end
		
		if (player.mo.cyclone == 1) and not (player.mo.bounce == 1)
		and (P_IsObjectOnGround(player.mo))
			A_ZThrust(player.mo, 5, 0)
			player.mo.cyclone = 0
			player.mo.bounce = 1
			player.mo.state = S_PLAY_HAMMER5
		end
		
		if (player.mo.bounce == 1)
		and (P_IsObjectOnGround(player.mo))
			player.mo.bounce = 0
			player.mo.cyclone = 0
		end
		
		if (player.mo.cyclone == 1) and P_PlayerInPain(player)
		or (player.mo.state == S_PLAY_SPRING)
		or P_IsObjectOnGround(player.mo)
			player.mo.cyclone = 0
		end
		
		if (player.mo.leap == 1)
		and (P_IsObjectOnGround(player.mo))
			player.mo.leap = 0
		end
		
		if (player.ctfname == nil)
		    player.ctfname = player.name
		end
	
	    if (player.mo.state == S_PLAY_HAMMER5) or (player.mo.state == S_PLAY_HAMMER6) or (player.mo.state == S_PLAY_CYCLONE) or (player.mo.state >= S_PLAY_TWIRL1) and (player.mo.state <= S_PLAY_TWIRL12)
		    player.charability = CA_GLIDEANDCLIMB
		else
	        player.charability = CA_NONE
		end
	
	    if not (player.mo.state == S_PLAY_CYCLONE)
		and (player.mo.cyclone == 1)
		    player.mo.cyclone = 0
		end
	end
end
	
addHook("MobjThinker", RosyHammer, MT_PLAYER)

addHook("MobjThinker", function(hammer)
	if (hammer.target and hammer.target.player) and not (hammer.scale == hammer.target.scale)
		hammer.scale = hammer.target.scale
		end
	if (hammer.target and hammer.target.player) and (hammer.target and hammer.target.state == S_PLAY_HAMMER6 and not CBW_Battle)
	local fa
	local ns
	local x
	local y
	local fake
	local heart
			for i = 0, 16, 1 do
				fa = i*ANGLE_22h
				ns = 20*FRACUNIT
				x = hammer.x + FixedMul(FixedMul(sin(fa),ns), hammer.scale)
				y = hammer.y + FixedMul(FixedMul(cos(fa),ns), hammer.scale)
				fake = P_SpawnMobj(x, y, hammer.z, MT_HEARTATTACK)
				fake.target = hammer.target
				fake.fuse = TICRATE/5
				fake.scale = hammer.scale
				fake.flags2 = $1|MF2_DEBRIS
				fake.momx = FixedMul(FixedMul(sin(fa),ns), fake.scale)
				fake.momy = FixedMul(FixedMul(cos(fa),ns), fake.scale)
				heart = P_SpawnMobj(x, y, hammer.z, MT_HEART)
				heart.target = hammer.target
				heart.fuse = TICRATE/5
				heart.scale = hammer.scale
				heart.flags2 = $1|MF2_DEBRIS
				heart.momx = FixedMul(FixedMul(sin(fa),ns), heart.scale)
				heart.momy = FixedMul(FixedMul(cos(fa),ns), heart.scale)
				end
			end
end, MT_CAPEHAMMER)

addHook("PlayerCanDamage", function(player)
    if player.skin == "rosy" and (player.mo.state == S_PLAY_HAMMER5) or (player.mo.state == S_PLAY_HAMMER6) or (player.mo.state == S_PLAY_CYCLONE) or (player.mo.state >= S_PLAY_TWIRL1) and (player.mo.state <= S_PLAY_TWIRL12) or (player.mo.state == S_PLAY_HAMMERDOWN5) or (player.mo.state == S_PLAY_HAMMERDOWN6)
    return true
    end
end)

addHook("PlayerCanDamage", function(player)
    if player.skin == "rosy" and (player.pflags & PF_SPINNING)
    return false
    end
end)

addHook("MobjCollide", function(spike, rosy)
	if not (rosy.player and rosy.skin == "rosy")
		return nil
	end
	if (rosy.z > spike.z+spike.height+10*FRACUNIT)
	or (spike.z > rosy.z+rosy.height)
		return nil 
	elseif (rosy.player.hammer == 1) or (rosy.player.mo.leap == 1) or (rosy.player.twirl == 1) or (rosy.player.mo.cyclone == 1)
		spike.health = 0
		S_StartSound(rosy, spike.info.deathsound)
		P_KillMobj(spike, rosy, rosy)
		return false
	end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, rosy)
	if not (rosy.player and rosy.skin == "rosy")
		return nil
	end
	if (rosy.z > spike.z+spike.height+10*FRACUNIT)
	or (spike.z > rosy.z+rosy.height)
		return nil 
	elseif (rosy.player.hammer == 1) or (rosy.player.mo.leap == 1) or (rosy.player.twirl == 1) or (rosy.player.mo.cyclone == 1)
		spike.health = 0
		S_StartSound(rosy, spike.info.deathsound)
		P_KillMobj(spike, rosy, rosy)
		return false
	end
end, MT_WALLSPIKE)

addHook("MobjMoveCollide", function(rosy, spring)
	if not (rosy.player and rosy.skin == "rosy") or not (spring.flags & MF_SPRING)
		return nil
	end
	if (rosy.player.hammer == 1) and (rosy.player.powers[pw_justsprung]) or (rosy.player.mo.leap == 1) and (rosy.player.powers[pw_justsprung]) or (rosy.player.twirl == 1) and (rosy.player.powers[pw_justsprung]) or (rosy.player.mo.cyclone == 1) and (rosy.player.powers[pw_justsprung])
		if not (spring.type == MT_REDHORIZ) and not (spring.type == MT_BLUEHORIZ) and not (spring.type == MT_YELLOWHORIZ)
			S_StartSound(rosy, sfx_sprong)
			rosy.state = S_PLAY_SPRING
			rosy.player.hammer = 0
			rosy.player.mo.leap = 0
			rosy.player.twirl = 0
			rosy.player.mo.cyclone = 0
			rosy.player.mo.momz = $ * 120/100
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
	    heartslinger.state = S_HEART
		heartslinger.heartsound = 1
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
	if (heartslinger.heartsound == 1)
	and not (heartslinger.noheartsound == 1)
	    S_StartSound(heartslinger, sfx_s3kb8)
		heartslinger.heartsound = 0
		heartslinger.noheartsound = 1
	end
    if (heartslinger)
	and (leveltime & 2) == 0
	   local sparkle = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z - 15*FRACUNIT, MT_SPARK)
	   sparkle.scale = heartslinger.scale
	   sparkle.fuse = TICRATE
	   sparkle.flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
    end
	if not (heartslinger.flags & MF_MISSILE)
	   S_StartSound(heartslinger, sfx_s3k8b)
	   heartslinger.fuse = 1
	   for i = 0, 16, 1 do
			local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = heartslinger.target
			local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
		    fake.fuse = TICRATE
			fake.target = heartslinger.target
			if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		        heart.sprite = SPR_CHRT
			    heart.frame = A
			    heart.color = heart.target.color
		    end
		end
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_REDRING)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_REDRING)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
	    heartslinger.color = SKINCOLOR_PINK
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
    if (heartslinger)
	and (leveltime & 2) == 0
	   local sparkle = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z - 15*FRACUNIT, MT_SPARK)
	   sparkle.scale = heartslinger.scale
	   sparkle.fuse = TICRATE
	   sparkle.flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
    end
	if not (heartslinger.flags & MF_MISSILE)
	   S_StartSound(heartslinger, sfx_s3k8b)
	   heartslinger.fuse = 1
	   for i = 0, 16, 1 do
			local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = heartslinger.target
			local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
		    fake.fuse = TICRATE
			fake.target = heartslinger.target
			if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		        heart.sprite = SPR_CHRT
			    heart.frame = A
			    heart.color = heart.target.color
		    end
		end
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_THROWNAUTOMATIC)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_THROWNAUTOMATIC)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
	    heartslinger.state = S_HEART
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
	if not (heartslinger.flags & MF_MISSILE)
	    heartslinger.fuse = 1
		local steps = 2
			repeat
				local area = 0
				repeat
					local size = 1
					local heart = P_SpawnMobj(heartslinger.x,heartslinger.y,heartslinger.z+heartslinger.height/2,MT_HEART)
					if heart and heart.valid then
						heart.target = heartslinger.target
						heart.thrust = true
						local div = 1
						if steps == 1 then div = 4 end
						P_SetObjectMomZ(heart,heart.scale*4/div)
						P_InstaThrust(heart,area*ANG1,heart.scale*2*size)
						heart.scale = $/2
						heart.fuse = 35
						heart.flags = $1 & ~MF_NOGRAVITY
						heart.flags = MF_NOBLOCKMAP|MF_MISSILE
						if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                    heart.sprite = SPR_CHRT
			                heart.frame = A
			                heart.color = heart.target.color
		                end
					end
					area = $+45/size
				until area >= 360
				steps = $-1
			until steps <= 0
			return nil
		end
    if (heartslinger)
	and (leveltime & 2) == 0
	   local sparkle = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z - 15*FRACUNIT, MT_SPARK)
	   sparkle.scale = heartslinger.scale
	   sparkle.fuse = TICRATE
	   sparkle.flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_THROWNSCATTER)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_THROWNSCATTER)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
	    heartslinger.state = S_HEART
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
    if (heartslinger)
	and (leveltime & 2) == 0
	   local sparkle = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z - 15*FRACUNIT, MT_SPARK)
	   sparkle.scale = heartslinger.scale
	   sparkle.fuse = TICRATE
	   sparkle.flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
    end
	if not (heartslinger.flags & MF_MISSILE)
	   S_StartSound(heartslinger, sfx_s3k8b)
	   heartslinger.fuse = 1
	   for i = 0, 16, 1 do
			local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = heartslinger.target
			local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
		    fake.fuse = TICRATE
			fake.target = heartslinger.target
			if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		        heart.sprite = SPR_CHRT
			    heart.frame = A
			    heart.color = heart.target.color
		    end
		end
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_THROWNBOUNCE)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_THROWNBOUNCE)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
	    heartslinger.state = S_HEART
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
    if (heartslinger)
	and (leveltime & 2) == 0
	   local sparkle = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z - 15*FRACUNIT, MT_SPARK)
	   sparkle.scale = heartslinger.scale
	   sparkle.fuse = TICRATE
	   sparkle.flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
    end
	if not (heartslinger.flags & MF_MISSILE)
	   S_StartSound(heartslinger, sfx_s3k8b)
	   heartslinger.fuse = 1
	   for i = 0, 16, 1 do
			local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = heartslinger.target
			local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
		    fake.fuse = TICRATE
			fake.target = heartslinger.target
			if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		        heart.sprite = SPR_CHRT
			    heart.frame = A
			    heart.color = heart.target.color
		    end
		end
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_THROWNEXPLOSION)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_THROWNEXPLOSION)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
		heartslinger.flags = MF_NOBLOCKMAP|MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
		heartslinger.color = SKINCOLOR_PINK
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
	if not (heartslinger.flags & MF_MISSILE)
	   S_StartSound(heartslinger, sfx_s3k8b)
	   heartslinger.fuse = 1
	   for i = 0, 16, 1 do
			local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = heartslinger.target
			local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
		    fake.fuse = TICRATE
			fake.target = heartslinger.target
			if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		        heart.sprite = SPR_CHRT
			    heart.frame = A
			    heart.color = heart.target.color
		    end
		end
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.angle = angle
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_THROWNGRENADE)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_THROWNGRENADE)

addHook("MobjThinker", function(heartslinger)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if (heartslinger)
	    heartslinger.state = S_HEART
		if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		    heartslinger.sprite = SPR_CHRT
			heartslinger.frame = A
			heartslinger.color = heartslinger.target.color
		end
	end
    if (heartslinger)
	and (leveltime & 2) == 0
	   local sparkle = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z - 15*FRACUNIT, MT_SPARK)
	   sparkle.scale = heartslinger.scale
	   sparkle.fuse = TICRATE
	   sparkle.flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
    end
	if not (heartslinger.flags & MF_MISSILE)
	   S_StartSound(heartslinger, sfx_s3k8b)
	   heartslinger.fuse = 1
	   for i = 0, 16, 1 do
			local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = heartslinger.target
			local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
		    fake.fuse = TICRATE
			fake.target = heartslinger.target
			if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		        heart.sprite = SPR_CHRT
			    heart.frame = A
			    heart.color = heart.target.color
		    end
		end
    end
	if not (leveltime & 3)	
	   local angle = ANG1*P_RandomRange(0,359)
	   local dist = heartslinger.scale*16
	   local x = P_ReturnThrustX(nil,angle,dist)
	   local y = P_ReturnThrustY(nil,angle,dist)
	   local z = P_RandomRange(-8,8)*heartslinger.scale
	   local heart = P_SpawnAlteredDirectionMissile(heartslinger,MT_LHRT,heartslinger.x+x,heartslinger.y+y,heartslinger.z+heartslinger.height/2,0)
	   if heart and heart.valid then
	       P_InstaThrust(heart,heart.angle,heart.scale*3)
		   P_SetObjectMomZ(heart,heart.scale*2)
		   heart.scale = $/4
		   heart.state = S_HEART
		   heart.fuse = 16
		   if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		       heart.sprite = SPR_CHRT
			   heart.frame = A
			   heart.color = heart.target.color
		       end
		   end
	   end
end, MT_THROWNINFINITY)

addHook("MobjMoveCollide", function(heartslinger, mobj)
    if not (heartslinger.target.skin == "rosy")
	    return nil
	end
	if not (heartslinger.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heartslinger.z+heartslinger.height)
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR) or (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_invulnerability] and not mobj.player.powers[pw_flashing] and not P_PlayerInPain(mobj.player))
		    if (mobj == heartslinger.target)
			    return nil
			else
			    S_StartSound(mobj, sfx_s3k8b)
			    heartslinger.fuse = 1
				for i = 0, 16, 1 do
			    	local heart = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEART)
			    	heart.momx = P_RandomRange(-24, 24)*FRACUNIT
					heart.momy = P_RandomRange(-24, 24)*FRACUNIT
					heart.momz = P_RandomRange(2, 24)*FRACUNIT
					heart.fuse = TICRATE
					heart.target = heartslinger.target
					local fake = P_SpawnMobj(heartslinger.x, heartslinger.y, heartslinger.z, MT_HEARTATTACK)
			    	fake.momx = P_RandomRange(-24, 24)*FRACUNIT
					fake.momy = P_RandomRange(-24, 24)*FRACUNIT
					fake.momz = P_RandomRange(2, 24)*FRACUNIT
					fake.fuse = TICRATE
					fake.target = heartslinger.target
					if (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		                heart.sprite = SPR_CHRT
			            heart.frame = A
			            heart.color = heart.target.color
		            end
			    end
			end
		end
	end
end, MT_THROWNINFINITY)

addHook("MobjThinker", function(heart)
	if (heart.target and heart.target.eflags & MFE_VERTICALFLIP) and not (heart.eflags & MFE_VERTICALFLIP)
		heart.eflags = $1|MFE_VERTICALFLIP
		end
	if not (heart.target and heart.target.eflags & MFE_VERTICALFLIP) and (heart.eflags & MFE_VERTICALFLIP)
		heart.eflags = $1 & ~MFE_VERTICALFLIP
		end
end, MT_HEARTATTACK)

addHook("MobjMoveCollide", function(heart, mobj)
	if not (heart.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heart.z+heart.height)
		if not ((gametype & GT_MATCH) and mobj.valid and mobj.health and mobj.flags & (MF_ENEMY|MF_BOSS)) or ((gametype & GT_MATCH or gametype & GT_CTF and not gametype & GT_RACE and not gametype & GT_COMPETITION) and mobj.valid and mobj.health and mobj.type == MT_PLAYER or CBW_Battle and mobj.valid and mobj.health and mobj.type == MT_PLAYER)
			P_DamageMobj(mobj, heart, heart.target)
		end
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR)
			P_KillMobj(mobj, heart, heart.target)
			end
	else
		return nil
	end
end, MT_HEARTATTACK)

addHook("MobjMoveCollide", function(heart, mobj)
	if not (heart.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heart.z+heart.height)
		if (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_shield])
			if (mobj.player.mo.skin == "rosy") or G_GametypeHasTeams() and not (mobj.player.ctfteam == heart.target.player.ctfteam) or (gametype & GT_MATCH) or (gametype & GT_HIDEANDSEEK) or (gametype & GT_TAG) and not (mobj.player.pflags & PF_TAGIT)
			    return nil
			else
			    P_SwitchShield(mobj.player, SH_PINK)
				S_StartSound(mobj, sfx_shield)
			end
		end
	end
end, MT_HEARTATTACK)

addHook("MobjThinker", function(fake)
	if (fake.target and fake.target.eflags & MFE_VERTICALFLIP) and not (fake.eflags & MFE_VERTICALFLIP)
		fake.eflags = $1|MFE_VERTICALFLIP
		end
	if not (fake.target and fake.target.eflags & MFE_VERTICALFLIP) and (fake.eflags & MFE_VERTICALFLIP)
		fake.eflags = $1 & ~MFE_VERTICALFLIP
		end
end, MT_HEART)

addHook("MobjThinker", function(blink)
	if not (blink.target and blink.target.player)
		P_LookForPlayers(blink)
		end
	if (blink.target and blink.target.player)
		A_ZThrust(blink, 6, 1<<16)
		end
	if (blink.target and blink.target.eflags & MFE_VERTICALFLIP) and not (blink.eflags & MFE_VERTICALFLIP)
		blink.eflags = $1|MFE_VERTICALFLIP
		end
	if not (blink.target and blink.target.eflags & MFE_VERTICALFLIP) and (blink.eflags & MFE_VERTICALFLIP)
		blink.eflags = $1 & ~MFE_VERTICALFLIP
		end
end, MT_BLINKHEART)

addHook("MobjThinker", function(orbit)
	if (orbit.target) and not ((orbit.target.state == S_PLAY_CYCLONE))
	    if (orbit.charming == 1)
		    return nil
	    else
		    orbit.fuse = 1
		end
	end
	if (orbit.target and orbit.target.eflags & MFE_VERTICALFLIP) and not (orbit.eflags & MFE_VERTICALFLIP)
		orbit.eflags = $1|MFE_VERTICALFLIP
		end
	if not (orbit.target and orbit.target.eflags & MFE_VERTICALFLIP) and (orbit.eflags & MFE_VERTICALFLIP)
		orbit.eflags = $1 & ~MFE_VERTICALFLIP
		end
end, MT_ORBITHEART)

addHook("MobjMoveCollide", function(orbit, mobj)
	if not (orbit.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > orbit.z+orbit.height)
		if not ((gametype & GT_MATCH) and mobj.valid and mobj.health and mobj.flags & (MF_ENEMY|MF_BOSS)) or ((gametype & GT_MATCH or gametype & GT_CTF and not gametype & GT_RACE and not gametype & GT_COMPETITION) and mobj.valid and mobj.health and mobj.type == MT_PLAYER or CBW_Battle and mobj.valid and mobj.health and mobj.type == MT_PLAYER)
			P_DamageMobj(mobj, orbit, orbit.target)
		end
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR)
			P_KillMobj(mobj, orbit, orbit.target)
			end
	else
		return nil
	end
end, MT_ORBITHEART)

addHook("MobjMoveCollide", function(heart, mobj)
	if not (heart.z-(5*FRACUNIT) > mobj.z+mobj.height)
	and not(mobj.z-(5*FRACUNIT) > heart.z+heart.height)
		if (mobj.valid and mobj.health and mobj.type == MT_PLAYER and not mobj.player.powers[pw_shield])
			if (mobj.player.mo.skin == "rosy") or G_GametypeHasTeams() and not (mobj.player.ctfteam == heart.target.player.ctfteam) or (gametype & GT_MATCH) or (gametype & GT_HIDEANDSEEK) or (gametype & GT_TAG) and not (mobj.player.pflags & PF_TAGIT)
			    return nil
			else
			    P_SwitchShield(mobj.player, SH_PINK)
				S_StartSound(mobj, sfx_shield)
			end
		end
	end
end, MT_ORBITHEART)

addHook("MobjThinker", function(heart)
	if heart and heart.valid then
		if heart.thrust then
			heart.extravalue2 = FRACUNIT
		else
			heart.thrust = false
		end
	end
end, MT_LHRT)

addHook("ShouldDamage", function(target, inflictor, source, damage)
	if not inflictor
		return nil
	end
	if inflictor.type == MT_HEARTATTACK
	and target == inflictor.target
		return false 
	end
	if inflictor.type == MT_HEARTATTACK
	and (target.player.ctfteam == inflictor.target.player.ctfteam) and not (gametype & GT_MATCH)
		return false
	end
end, MT_PLAYER)

local function RosyTouch(rosy)
     if not (rosy and rosy.player and rosy.skin == "rosy")
	     return
     end
     if (rosy.player.mo.slidestate == 1)
	     return false
     end
end

addHook("ShouldDamage", RosyTouch)

addHook("HurtMsg", function(p, inflictor, source)
if not inflictor
	return nil
	end
if p.ctfteam == 0
    p.ctfname = p.name
elseif p.ctfteam == 1
	p.ctfname = "\x85"..p.name.."\x80"
elseif p.ctfteam == 2
	p.ctfname = "\x84"..p.name.."\x80"
	end
if ((inflictor.type == MT_PLAYER) and (inflictor.player.hammer == 1))
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and not CBW_Battle
		print(inflictor.player.ctfname.."'s hammer killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and not CBW_Battle
        print(inflictor.player.ctfname.."'s hammer whacked "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_HEARTATTACK)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		print(source.player.ctfname.."'s heart shockwave killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
        print(source.player.ctfname.."'s heart shockwave lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_ORBITHEART)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		print(source.player.ctfname.."'s orbiting hearts killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
        print(source.player.ctfname.."'s orbiting hearts lovestruck "..p.ctfname..".")
        return true
		end
	end
end
end)

addHook("HurtMsg", function(p, inflictor, source) //Heartslinger Messages
if not inflictor
	return nil
	end
if p.ctfteam == 0
    p.ctfname = p.name
elseif p.ctfteam == 1
	p.ctfname = "\x85"..p.name.."\x80"
elseif p.ctfteam == 2
	p.ctfname = "\x84"..p.name.."\x80"
	end
if (inflictor.type == MT_REDRING)
	if p.mo.health < 1
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		and not (inflictor.flags2 & MF2_RAILRING)
		print(source.player.ctfname.."'s thrown heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		and not (inflictor.flags2 & MF2_RAILRING)
        print(source.player.ctfname.."'s thrown heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_THROWNAUTOMATIC)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		print(source.player.ctfname.."'s automatic heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
        print(source.player.ctfname.."'s automatic heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_THROWNSCATTER)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		print(source.player.ctfname.."'s scatter heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
        print(source.player.ctfname.."'s scatter heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_THROWNBOUNCE)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		print(source.player.ctfname.."'s bounce heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
        print(source.player.ctfname.."'s bounce heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_THROWNEXPLOSION)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		print(source.player.ctfname.."'s explosion heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
        print(source.player.ctfname.."'s explosion heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_THROWNGRENADE)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		print(source.player.ctfname.."'s grenade heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
        print(source.player.ctfname.."'s grenade heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_THROWNINFINITY)
	if p.mo.health < 1 
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		print(source.player.ctfname.."'s infinity heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
        print(source.player.ctfname.."'s infinity heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
if (inflictor.type == MT_REDRING)
	if p.mo.health < 1
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		and (inflictor.flags2 & MF2_RAILRING)
		print(source.player.ctfname.."'s rail heart killed "..p.ctfname..".")
        return true
        end
    else
		if not (p.powers[pw_invulnerability])
		and (inflictor.target.skin == "rosy")
		and (inflictor.flags2 & MF2_RAILRING)
        print(source.player.ctfname.."'s rail heart lovestruck "..p.ctfname..".")
        return true
		end
	end
end
end)

local function HedgehogHammer(rosy, notrosy)
if not G_RingSlingerGametype() return nil else
    if not (rosy.z+(1*FRACUNIT) > notrosy.z+notrosy.height)
    and not (notrosy.z+(1*FRACUNIT) > rosy.z+rosy.height)
        if (notrosy.valid and notrosy.health and notrosy.player)
        and (notrosy != rosy.target)
        and (rosy.player.hammer == 1)
        and not (notrosy.player.powers[pw_flashing])
        and not ((gametype == GT_TEAMMATCH or gametype == GT_CTF or gametype == GT_TAG) and notrosy.player.ctfteam == rosy.player.ctfteam and not notrosy.player.pflags & PF_TAGIT)
            P_DamageMobj(notrosy, rosy, rosy)
        end        
    else
        return nil
    end
end
end

local function noSpinDamage(enemy, rosy)
	local player = rosy.player
	if not (player.mo.skin == "rosy")
		return false
	end
	if (enemy.flags & (MF_ENEMY|MF_BOSS))
	and (player.pflags & PF_SPINNING)
	and not (player.powers[pw_super])
	and not (player.powers[pw_invulnerability])
	and not (player.powers[pw_carry] == CR_MACESPIN)
	and not (player.powers[pw_carry] == CR_ZOOMTUBE)
		P_DamageMobj(rosy, enemy, enemy)
		return true
	end
end

local function heartDamage(heart, player)
	if (heart.target.ctfteam == player.ctfteam)
		return false
	end
	if (player.type == MT_PLAYER)
	and (player.health)
	and (player.valid)
	and (heart.thrust)
	and not (player.powers[pw_super])
	and not (player.powers[pw_invulnerability])
		P_DamageMobj(player, heart, heart.target)
		return true
	end
end

addHook("MobjMoveCollide", HedgehogHammer, MT_PLAYER)
addHook("MobjCollide", HedgehogHammer, MT_PLAYER)
addHook("TouchSpecial", noSpinDamage)
addHook("TouchSpecial", heartDamage, MT_LHRT)